{$A+,B-,D-,E+,F-,I+,L-,N-,O-,R-,S+,V-}
{$M 4000,0,655360}

program split80;
uses dos,tpdos,tpcrt,tpstring,tpedit,tpasciiz;
const
    Reverse = $78;
var
    FileIn,FileOut :Text;
    SourceFile,DestFile : String;
    Recin, Recout : Asciiz;
    Lrecl,NumSplits,Start,N : Integer;
    Result : Word;
    Escaped : Boolean;
    RecRead,RecWrite : LongInt;
  {--------------------------------------------------------------------}
Function OpenFile(Var DFile : Text; Fname : String; R: Boolean):Boolean;
begin
  OpenFile := True;
  Assign(DFile, Fname);
  {$I-}
  if R
  then ReSet(DFile)
  else ReWrite(DFile);
  {$I+} { open file }
  Result := IOResult;
  If Result <> 0
  Then Begin
    FastText('Error opening ' + JustFilename(Fname) + ', IOResult = ' + Long2Str(Result),25,2);
    OpenFile := False;
  end;
end;
{----------------------------------------------------------------------}
Function CloseFile(Var DFile : Text; Fname : String): Boolean;
begin
   {$I-}
   CloseFile := True;
   Close(Dfile);
   Result := IOResult;
   if (Result <> 0)
   Then Begin
    FastText('Error closing ' + JustFilename(Fname) + ', IOResult = ' + Long2Str(Result),25,2);
    CloseFile := False;
   End;
   {$I+}
end;

{----------------------------------------------------------------------}
begin {Split80}
  ClrScr;
  ForceUpper := true;
  SourceFile := '';
  ReadString('Enter filename to split : ',10,18,12,TextAttr,Reverse,TextAttr,
              Escaped,SourceFile);
  if Escaped then Exit;
  Lrecl := 0;
  ReadInteger('Enter LRECL of records  : ',11,18,12,TextAttr,Reverse,1,10000,
              Escaped,Lrecl);
  if Escaped then Exit;

  { figure number of 80 byte chunks per input record }
  NumSplits := Lrecl div 80;
  N := Lrecl - (80 * NumSplits);
  if N > 0 then Inc(NumSplits);

  DestFile := ForceExtension(SourceFile,'SPL');
  If not OpenFile(FileIn,SourceFile,true) then Exit;
  If not OpenFile(FileOut,DestFile,false) then Exit;

  FastWrite(' Spliting '+ SourceFile + ' to ' + DestFile +'... ',13,18,Reverse);
  RecRead := 0;
  RecWrite := 0;

  { Write NumSplits so we can put it back together }
  writeln(FileOut,LeftPadCh(Long2Str(NumSplits),'0',2));

  FastText('Records Read   Records Written   Ratio',15,18);
  FastWrite(' 1/'+ Long2Str(NumSplits)+' ',16,51,Reverse);

  { Do it...}
  while not eof(FileIn) do
  begin
    if not ReadLnAsc(Filein,Recin) then
    begin
      Result := IOResult;
      FastText('Error reading ' + JustFilename(SourceFile),25,2);
      Exit;
    end;
    inc(RecRead);
    FastWrite(LeftPad(Long2Str(RecRead),6),16,21,Reverse);
    Start := 0;
    for N := 1 to NumSplits do
    begin
      Str2Asc('',Recout);
      CopyAsc(Recin,Start,80,Recout);
      if not WriteAsc(Fileout,Recout) then
      begin
        FastText('Error writing ' + JustFilename(DestFile),25,2);
        Exit;
      end;
      WriteLn(Fileout);
      inc(RecWrite);
      FastWrite(LeftPad(Long2Str(RecWrite),6),16,38,Reverse);
      Inc(Start,80);
    end;
  end;
  If not CloseFile(FileOut,DestFile) then Exit;
end.
